#ifndef _ACQ_HPP_
#define _ACQ_HPP_

#define MAX_IMPLANT_SIGNAL_COUNT 8U
#define ACQ_BULK_SIZE 1 + 1 + 3 + 2 + 2 + 3 + 6 + (2 * MAX_IMPLANT_SIGNAL_COUNT)

typedef union 
{
	unsigned char bulk[ACQ_BULK_SIZE];
	struct{
		unsigned char vF_status;
		unsigned char Action_status;
		unsigned char Pressure[3U];
		unsigned char Temp[2U];
		unsigned char Humidity[2U];
		unsigned char Micro[2U];
		unsigned char Reserved[6U];
		unsigned char Implant[3U * MAX_IMPLANT_SIGNAL_COUNT];
	} __attribute__((__packed__));
} vF_Acq_Frame;

class Acquisition
{
	public :
	static void Setup(void);
	static void Enable(void);
	static void Disable(void);
	static void Detect(unsigned char* state);
	static void OnTick(void);
	private :
	static void Acq_Task(void* context);
	static void Query_Task(void* context);
};

#endif //_ACQ_HPP_
