// ADC driver for nRF52840 | gat 11/04/23
#ifndef _ADC_H_
#define _ADC_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum 
{
	ADC_Status_OK,
	ADC_Status_No_Chann_Available,
	ADC_Status_Chann_Not_Found
} ADC_Status;

typedef enum 
{
	ADC_Input_Range_Vdd, // gain 1/4 (input range = Vdd)
	ADC_Input_Range_Vdd_2 // gain 1/2 (input range = Vdd/2)
} ADC_Gain;

typedef enum 
{
	ADC_Analog_Input_0 = 1,
	ADC_Analog_Input_1,
	ADC_Analog_Input_2,
	ADC_Analog_Input_3,
	ADC_Analog_Input_4,
	ADC_Analog_Input_5,
	ADC_Analog_Input_6,
	ADC_Analog_Input_7,
	ADC_Analog_Input_Vdd,
	ADC_Analog_Input_Vddh_div_5 = 0x0D
} ADC_Analog_Input;

void ADC_Init();

void ADC_Start(void);

void ADC_Stop(void);

void ADC_Register_Callback(void (*user_Callback)(void));

void ADC_Sample(void* p_data);

ADC_Status ADC_Add_Channel(ADC_Analog_Input AnalogInput, ADC_Gain Gain);

ADC_Status ADC_Remove_Channel(ADC_Analog_Input AnalogInput);

#ifdef __cplusplus
}
#endif

#endif // _ADC_H_
