// Differential Pressure Transducer Middleware | gat 12/04/23
#ifndef _DPT_HPP_
#define _DPT_HPP_

#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

#define Data_size 4U

typedef enum {
	DPT_Success,
	DPT_Timeout,
	DPT_MutexError
} DPT_Return;

class DPT
{
	public:
	static void Setup(TaskHandle_t* query_task);
	static DPT_Return ReadDataBlocking(void);
	static DPT_Return ReadData(void);
	static DPT_Return StartBlocking(void);
	static DPT_Return Start(void);
	static unsigned char* GetDataPtr(void);
	static void GetSample(unsigned char* data_ptr);
	private:
	static void GetStatus(void);
	static void EndOfConversion(void);
	static void SwapDataPtr(void);
	static unsigned char* GetReadDataPtr(void);
	static unsigned char* GetWriteDataPtr(void);
};

#endif //_DPT_HPP_